package amigosJ2EE.integracion;

import amigosJ2EE.negocio.UsuarioTO;

/**
 * Interfaz genérico que deben implementar todos los Data Access Object que proporcionen acceso
 * a la información de los usuarios. Podría haber varias implementaciones: una que sacara los datos de
 * una base de datos relacional, otra que los sacara de documentos XML, etc.
 */
public interface UsuarioDAO {
	/**
	 * Crear un nuevo usuario
	 * @param usuario DTO con los datos del usuario a crear 
	 * @throws DataException
	 */
	public void crear(UsuarioTO usuario) throws DataException;
	public UsuarioTO buscar(String login) throws DataException;
	//TODO: sustituir UsuarioTO por otro TO con menos datos, ya que en el listado no se ven todos
	public UsuarioTO[] buscar(int edadMin, int edadMax, String localidad, int sexo) throws DataException;
	//TODO: definir m�todos para eliminar y modificar usuarios
}