package amigosJ2EE.presentacion;

import javax.servlet.*;
import javax.servlet.http.*;
import java.util.Map;
import java.util.HashMap;
import java.io.*;

import amigosJ2EE.presentacion.acciones.*;


public class Controlador extends HttpServlet {

  private final String PARAM_ACCION = "accion";

  private Map acciones;
  
  public void init () throws ServletException {    
    acciones = new HashMap();
    acciones.put("prueba", new AccionPrueba());     
    acciones.put("login", new AccionLogin());     
	acciones.put("inicioRegistro", new AccionInicioRegistro());     
	acciones.put("registro", new AccionRegistro());     
	acciones.put("inicioBusqueda", new AccionInicioBusqueda());     
	acciones.put("busqueda", new AccionBusqueda());     
  }
  
  public void doGet (HttpServletRequest request, 
                     HttpServletResponse response) 
    throws ServletException, IOException 
  {
    doPost (request, response);
  }

  public void doPost (HttpServletRequest request, 
                      HttpServletResponse response) 
    throws ServletException, IOException 
  {
    String nomAccion;
    Accion ac;
    String nomVista = null;
    
    try {
	    //obtener de un par�metro HTTP el nombre de la acci�n 
	    nomAccion = obtNomAccion(request);
	   
	    //a partir del nombre, obtener la clase asociada a la acci�n y procesarla   
	    ac = getAccion(nomAccion);	
		nomVista = ac.procesar (getServletContext(), request, response);
	    	    
	    //mostrar la vista asociada a la accion
	    if (nomVista!=null)
	       mostrarVista(nomVista, request, response);
    }
    catch(Exception e) {
    	throw new ServletException(e);
    }

  }

  private String obtNomAccion (HttpServletRequest request) throws Exception {
    String nomAccion;
    
    nomAccion = request.getParameter(PARAM_ACCION);
    if (nomAccion == null || !acciones.containsKey(nomAccion)) {
      throw new Exception("Accion desconocida " + nomAccion);
    }
    return nomAccion;
  }

  private Accion getAccion (String nomAccion) throws Exception {
    Accion a;
    
    a = (Accion) acciones.get(nomAccion);
    if (a==null) 
       throw new Exception("Accion desconocida " + nomAccion);    
    else return a;
  }
      
  	
  private void mostrarVista(String vista, HttpServletRequest request, 
                   HttpServletResponse response) 
                   throws ServletException, IOException {
     RequestDispatcher rd;
     
     rd = request.getRequestDispatcher(vista);
     rd.forward(request, response);           	
  }	

}
