package amigosJ2EE.presentacion.acciones;

import javax.servlet.*;
import javax.servlet.http.*;
import java.util.*;
import amigosJ2EE.negocio.*;
import amigosJ2EE.Constantes;
import amigosJ2EE.presentacion.*;

public class AccionBusqueda extends Accion {
   
   public String procesar(ServletContext sc, HttpServletRequest request, 
                 HttpServletResponse response) throws Exception {
		UsuarioDelegate delegate;
		UsuarioTO[] lista;
		int edadMin, edadMax;
		int sexo;
		String sexoCad;
		String localidad;
		List errores;
				
		errores = new ArrayList();		
		//sacar los parametros de la peticion
		edadMin = 0;
		edadMax = 100;
		try {
			edadMin = Integer.parseInt(request.getParameter("edadMin"));
		}
		catch(NumberFormatException nfe) {
			errores.add(new ErrorValidacion("La edad minima no es correcta"));
		}
		try {
			edadMax = Integer.parseInt(request.getParameter("edadMax"));
		}
		catch(NumberFormatException nfe) {
			errores.add(new ErrorValidacion("La edad maxima no es correcta"));			
		}
		sexoCad = request.getParameter("sexo");
		if (sexoCad.equalsIgnoreCase("i"))
			sexo = Constantes.SEXO_INDIFERENTE;
		else if (sexoCad.equalsIgnoreCase("v"))
				sexo = Constantes.SEXO_VARON;
			 else
			 	sexo = Constantes.SEXO_MUJER;
		System.out.println("\n\n\n\nEL SEXO ES:" + sexo + "\n\n\n\n");
		//localidad en blanco es null
		localidad = request.getParameter("localidad");
		if ((localidad==null)||(localidad.equals("")))
				localidad = null;
		//si ha habido errores, colocarlos en la peticion
		//para que se puedan mostrar desde el JSP
		if (!errores.isEmpty())
			request.setAttribute("errores", (ErrorValidacion[]) errores.toArray(new ErrorValidacion[0]));				 	
		//en caso contrario, efectuar la busqueda	 	
		else {
			delegate = new UsuarioDelegate();
			lista = delegate.buscar(edadMin, edadMax, localidad, sexo);
			request.setAttribute("lista", lista);
		}
		
		return "busqueda.jsp";      	
   }
           		
}	