package amigosJ2EE.presentacion.acciones;

import javax.servlet.*;
import javax.servlet.http.*;
import amigosJ2EE.negocio.*;

/**
 * Acción que implementa el login de un usuario en el sistema.
 * Ejemplo de implementación del patrón Command (parte de MVC - o en J2EE "Service to Worker").
 */
public class AccionLogin extends Accion {
   
   public String procesar(ServletContext sc, HttpServletRequest request, 
                 HttpServletResponse response) throws Exception {
      UsuarioDelegate del;
      UsuarioTO usuario;
      
      del = new UsuarioDelegate();
      try {
      	//hacer login
		usuario = del.login(request.getParameter("login"), request.getParameter("password"));
		//colocar datos del usuario en request para que acceda a ellos la vista
		request.setAttribute("usuario", usuario);                 
		return "home.jsp";                 	
      }
      //el usuario no existe o el password no es correcto
      catch(LoginErrorException le) {
      	return "errorlogin.html";      	
      }
   }
               		
}	