package amigosJ2EE.presentacion.acciones;

import javax.servlet.*;
import javax.servlet.http.*;
import java.text.*;

import amigosJ2EE.AmigosJ2EEException;
import amigosJ2EE.negocio.*;

public class AccionRegistro extends Accion {
   
   public String procesar(ServletContext sc, HttpServletRequest request, 
                 HttpServletResponse response) throws Exception {
		UsuarioTO usuario;
		UsuarioDelegate delegate;		
		
		//TODO: validacion de datos: fecha, pw1==pw2,...
		usuario = crearUsuario(request);
		delegate = new UsuarioDelegate();
		//TODO: capturar excepcion de registro y convertirla en error
		delegate.registro(usuario);
      	return "finregistro.jsp";                 	
   }
   
   /**
    * Crea un DTO con los datos del usuario a partir de los contenidos
    * en la peticion HTTP.
    * @param request
    * @return
    */
   private UsuarioTO crearUsuario(HttpServletRequest request) throws AmigosJ2EEException {
		UsuarioTO usuario;
		SimpleDateFormat df;
		
		usuario = new UsuarioTO();
		usuario.setLogin(request.getParameter("login"));
		usuario.setPassword(request.getParameter("password1"));
		usuario.setDescripcion(request.getParameter("descripcion"));
		usuario.setLocalidad(request.getParameter("localidad"));
		if (request.getParameter("sexo").equalsIgnoreCase("v"))
			usuario.setVaron(true);
		else
			usuario.setVaron(false);
		df = new SimpleDateFormat("dd-MM-yyyy");
		try {	
			usuario.setFechaNac(df.parse(request.getParameter("fechaNac")));			
		}
		catch(ParseException pe) {
			throw new AmigosJ2EEException("Error en fecha de nacimiento");
		}
		return usuario;
   }
               		
}	